<?php
function neuroconcierge_test($sourceId, $img = null, $copy = true)
{
    $shouldDeleteImg = false;
    $source = SQLSelectOne("SELECT * FROM neuroconcierge_sources WHERE ID=" . $sourceId);
    $queuePath = __DIR__ . "/../modules/neuroconcierge/data/queue/$sourceId/";
    $newFileNameDateFormat = 'YmdHis';
    if ($img == null) {
        if ($copy) {
            $img = $queuePath . date($newFileNameDateFormat) . '.jpg';
        } else {
            $img = __DIR__ . "/../modules/neuroconcierge/data/tmp/" . date($newFileNameDateFormat) . '.jpg';
            $shouldDeleteImg = true;
        }
        file_put_contents($img, file_get_contents($source['URL']));
    } else {
        if ($copy) {
            $copyToPath = $queuePath . basename($img);
            if (file_exists($copyToPath)) {
                $copyToPath = $queuePath . date($newFileNameDateFormat) . '.jpg';
            }
            copy($img, $copyToPath);
        }
    }
    require_once(__DIR__ . '/../modules/neuroconcierge/functions.php');

    $testResults = neuroconcierge_test_multiple($sourceId, array($img));
    if ($testResults !== false) {
        return reset($testResults);
    } else {
        return false;
    }
}

function neuroconcierge_test_multiple($sourceId, $images)
{
    $trainFilePath = realpath(__DIR__ . '/../modules/neuroconcierge/data/train' . $sourceId . '.net');
    if (file_exists($trainFilePath)) {
        $people = json_decode(file_get_contents(__DIR__ . "/../modules/neuroconcierge/data/people$sourceId.json"));
        $source = SQLSelectOne("SELECT * FROM neuroconcierge_sources WHERE ID=" . $sourceId);
        $ann = fann_create_from_file($trainFilePath);

        $probabilitiesByPerson = [];
        foreach ($images as $image) {
            $testResults = fann_run($ann,
                parseImage(
                    $image,
                    $source['X'],
                    $source['Y'],
                    $source['WIDTH'],
                    $source['HEIGHT'],
                    $source['RESIZE_WIDTH']
                )
            );
            for ($i = 0; $i < sizeof($testResults); $i++) {
                $probabilitiesByPerson[$image][$people[$i]] = $testResults[$i];
            }
        }
        fann_destroy($ann);
        return $probabilitiesByPerson;
    } else {
        return false;
    }
}
