<?php
/**
 * Neuro Concierge
 * @package project
 * @author Wizard <sergejey@gmail.com>
 * @copyright http://majordomo.smartliving.ru/ (c)
 * @version 0.1 (wizard, 16:01:04 [Jan 21, 2024])
 */
//
//
class neuroconcierge extends module
{
    /**
     * neuroconcierge
     *
     * Module class constructor
     *
     * @access private
     */
    function __construct()
    {
        $this->name = "neuroconcierge";
        $this->title = "Нейроконсьерж";
        $this->module_category = "<#LANG_SECTION_APPLICATIONS#>";
        $this->checkInstalled();
    }

    /**
     * saveParams
     *
     * Saving module parameters
     *
     * @access public
     */
    function saveParams($data = 1)
    {
        $p = array();
        if (isset($this->id)) {
            $p["id"] = $this->id;
        }
        if (isset($this->view_mode)) {
            $p["view_mode"] = $this->view_mode;
        }
        if (isset($this->edit_mode)) {
            $p["edit_mode"] = $this->edit_mode;
        }
        if (isset($this->tab)) {
            $p["tab"] = $this->tab;
        }
        return parent::saveParams($p);
    }

    /**
     * getParams
     *
     * Getting module parameters from query string
     *
     * @access public
     */
    function getParams()
    {
        global $id;
        global $mode;
        global $view_mode;
        global $edit_mode;
        global $tab;
        if (isset($id)) {
            $this->id = $id;
        }
        if (isset($mode)) {
            $this->mode = $mode;
        }
        if (isset($view_mode)) {
            $this->view_mode = $view_mode;
        }
        if (isset($edit_mode)) {
            $this->edit_mode = $edit_mode;
        }
        if (isset($tab)) {
            $this->tab = $tab;
        }
    }

    /**
     * Run
     *
     * Description
     *
     * @access public
     */
    function run()
    {
        global $session;
        $out = array();
        if ($this->action == 'admin') {
            $this->admin($out);
        } else {
            $this->usual($out);
        }
        if (isset($this->owner->action)) {
            $out['PARENT_ACTION'] = $this->owner->action;
        }
        if (isset($this->owner->name)) {
            $out['PARENT_NAME'] = $this->owner->name;
        }
        $out['VIEW_MODE'] = $this->view_mode;
        $out['EDIT_MODE'] = $this->edit_mode;
        $out['MODE'] = $this->mode;
        $out['ACTION'] = $this->action;
        $out['TAB'] = $this->tab;
        $this->data = $out;
        $p = new parser(DIR_TEMPLATES . $this->name . "/" . $this->name . ".html", $this->data, $this);
        $this->result = $p->result;
    }

    /**
     * BackEnd
     *
     * Module backend
     *
     * @access public
     */
    function admin(&$out)
    {
        if (isset($this->data_source) && !$_GET['data_source'] && !$_POST['data_source']) {
            $out['SET_DATASOURCE'] = 1;
        }
        if ($this->data_source == 'neuroconcierge' || $this->data_source == '') {
            if ($this->view_mode == '' || $this->view_mode == 'search_sources_neuroconcierge') {
                $this->search_sources_neuroconcierge($out);
            }
            if ($this->view_mode == 'edit_sources_neuroconcierge') {
                $this->edit_sources_neuroconcierge($out, $this->id);
            }
            if ($this->view_mode == 'delete_sources_neuroconcierge') {
                $this->delete_sources_neuroconcierge($this->id);
                $this->redirect("?");
            }
            if ($this->view_mode == 'search_photos_all_neuroconcierge' || $this->view_mode == 'search_photos_queue_neuroconcierge') {
                $this->search_photos_neuroconcierge($out);
            }
            if ($this->view_mode == 'search_people_neuroconcierge') {
                $this->search_people_neuroconcierge($out);
            }
            if ($this->view_mode == 'edit_people_neuroconcierge') {
                $this->edit_people_neuroconcierge($out, $this->id);
            }
            if ($this->view_mode == 'delete_people_neuroconcierge') {
                $this->delete_people_neuroconcierge($this->id);
                $this->redirect("?");
            }
            if ($this->view_mode == 'train_neuroconcierge') {
                $this->train_neuroconcierge($out, $this->id);
            }
            if ($this->view_mode == 'test_neuroconcierge') {
                $this->test_neuroconcierge($out, $this->id);
            }
        }
    }

    /**
     * FrontEnd
     *
     * Module frontend
     *
     * @access public
     */
    function usual(&$out)
    {
        $this->admin($out);
    }

    /**
     * neuroconcierge search
     *
     * @access public
     */
    function search_sources_neuroconcierge(&$out)
    {
        require(dirname(__FILE__) . '/neuroconcierge_sources_search.inc.php');
    }

    /**
     * neuroconcierge edit/add
     *
     * @access public
     */
    function edit_sources_neuroconcierge(&$out, $id)
    {
        require(dirname(__FILE__) . '/neuroconcierge_sources_edit.inc.php');
    }

    /**
     * neuroconcierge delete record
     *
     * @access public
     */
    function delete_sources_neuroconcierge($id)
    {
        $rec = SQLSelectOne("SELECT * FROM neuroconcierge_sources WHERE ID='$id'");
        // some action for related tables
        SQLExec("DELETE FROM neuroconcierge_sources WHERE ID='" . $rec['ID'] . "'");
        SQLExec("DELETE FROM neuroconcierge_people WHERE SOURCE='" . $rec['ID'] . "'");
    }

    function search_photos_neuroconcierge(&$out)
    {
        require(dirname(__FILE__) . '/neuroconcierge_photos_search.inc.php');
    }

    function search_people_neuroconcierge(&$out)
    {
        require(dirname(__FILE__) . '/neuroconcierge_people_search.inc.php');
    }

    function edit_people_neuroconcierge(&$out, $id)
    {
        require(dirname(__FILE__) . '/neuroconcierge_people_edit.inc.php');
    }

    function delete_people_neuroconcierge($id)
    {
        $rec = SQLSelectOne("SELECT * FROM neuroconcierge_people WHERE ID='$id'");
        // some action for related tables
        SQLExec("DELETE FROM neuroconcierge_people WHERE ID='" . $rec['ID'] . "'");
    }

    function train_neuroconcierge(&$out, $id)
    {
        require(dirname(__FILE__) . '/neuroconcierge_train.inc.php');
    }

    function test_neuroconcierge(&$out, $id)
    {
        require(dirname(__FILE__) . '/neuroconcierge_test.inc.php');
    }

    /**
     * Install
     *
     * Module installation routine
     *
     * @access private
     */
    function install($data = '')
    {
        parent::install();
    }

    /**
     * Uninstall
     *
     * Module uninstall routine
     *
     * @access public
     */
    function uninstall()
    {
        SQLExec('DROP TABLE IF EXISTS neuroconcierge_sources');
        parent::uninstall();
    }

    /**
     * dbInstall
     *
     * Database installation routine
     *
     * @access private
     */
    function dbInstall($data)
    {
        /*
        neuroconcierge_sources -
        */
        $data = <<<EOD
 neuroconcierge_sources: ID int(10) unsigned NOT NULL auto_increment
 neuroconcierge_sources: TITLE varchar(100) NOT NULL DEFAULT ''
 neuroconcierge_sources: URL varchar(255) NOT NULL DEFAULT ''
 neuroconcierge_sources: SHRINK_DATA tinyint(1) unsigned NOT NULL
 neuroconcierge_sources: SHRINK_DATA_VALUE int(10) unsigned NOT NULL
 neuroconcierge_sources: SHRINK_DATA_PERSON varchar(15) NOT NULL DEFAULT ''
 neuroconcierge_sources: USE_MULTI_PERSON_PHOTOS tinyint(1) unsigned NOT NULL
 neuroconcierge_sources: SHUFFLE_DATA tinyint(1) unsigned NOT NULL
 neuroconcierge_sources: X int(10) unsigned NOT NULL
 neuroconcierge_sources: Y int(10) unsigned NOT NULL
 neuroconcierge_sources: WIDTH int(10) unsigned NOT NULL
 neuroconcierge_sources: HEIGHT int(10) unsigned NOT NULL
 neuroconcierge_sources: RESIZE_WIDTH int(10) unsigned NOT NULL
 neuroconcierge_sources: HIDDEN_LAYERS_COUNT tinyint(1) unsigned NOT NULL
 neuroconcierge_sources: FIRST_HIDDEN_LAYER_NEURONS int(10) unsigned NOT NULL
 neuroconcierge_sources: SECOND_HIDDEN_LAYER_NEURONS int(10) unsigned NOT NULL
 neuroconcierge_sources: ACCURACY tinyint(1) unsigned NOT NULL
 neuroconcierge_people: ID int(10) unsigned NOT NULL auto_increment
 neuroconcierge_people: SOURCE int(10) unsigned NOT NULL
 neuroconcierge_people: TITLE varchar(30) NOT NULL DEFAULT ''
 neuroconcierge_people: NAME varchar(15) NOT NULL DEFAULT ''
EOD;
        parent::dbInstall($data);
    }
// --------------------------------------------------------------------
}
/*
*
* TW9kdWxlIGNyZWF0ZWQgSmFuIDIxLCAyMDI0IHVzaW5nIFNlcmdlIEouIHdpemFyZCAoQWN0aXZlVW5pdCBJbmMgd3d3LmFjdGl2ZXVuaXQuY29tKQ==
*
*/
